' Parameters: ("Main","<debug(optional)>|<device(optional)>")
'--------------------------------------------------------------------------
'                     PLUGWISE integration for HOMESEER
' 	         	   by DJF3 - http://www.domoticaworld.com 
' version 0.10 - Dec-31 2010: Re-wrote all code moving from >350 lines to <100 lines.
'				 Mar-01 2011: Updated code and readme with new parameters and changes
' Parameter: strDebug: 0=Off  1=On  (default=Off)
' NOTE: The Homeseer device codes must match the PLUGWISE device-ID's
'		Result: PW device ID 14 will update HS device Q14 (if you configured pwHC as 'Q')
'		See the readme.txt for more information
' TODO: build in check to see if PW device exists? Auto-create devices?

sub Main(byVal parm)

Dim strDATA As String
Dim varVersion, strDevice as String
Dim strStartDev, strStopDev as Integer
Dim strCount, strDebug as Integer
Dim varITEM, varDATA as String
Dim pwHC, pwSTRING, pwICON as String
Dim pwHOUSETOTAL as Integer
Dim pwID, pwCURRENT, pwSTATUS, pwTOTAL, pwSWITCH, pwONLINE as String
Dim strRSS_1url,strRSS_2path,strRSS_3port as String
Dim pwCOUNT, pwDCtotal

pwHC = "Q"
pwDCtotal = "Q98"
strRSS_1url  = "http://10.1.1.1"
strRSS_2path = "/DJ_Plugwise_RSS_03.xml"
strRSS_3port = "8181" 

varVersion = "0.10"
varVersion = "DJ_Plugwise" & varVersion 
strDebug = Cint(hs.stringitem(Parm,1,"|"))
strDevice = hs.stringitem(Parm,2,"|")
strStartDev = 1
If Cstr(strDebug) = "" then strDebug = 0
'strDebug = 1	'uncomment beginning of line to manually override debug level

Try	'---------- Block B: Get data from RSS feed and check the number of PW devices
	strDATA = hs.GetURL(strRSS_1url,strRSS_2path,False,strRSS_3port)
	If strDebug > 0 then hs.writelog(varVersion,"-------" & strDATA)
	If Len(strDATA)=0 then hs.writelog (varVersion,"Unable to get data - check internet"):exit sub
	pwCOUNT = Ubound(Split(strDATA,"<item>"))
	If strDebug > 0 then hs.writelog(varVersion,"<b>COUNT:" & pwCOUNT & "</b>")
Catch ex As Exception
	hs.writelog(varVersion,"Error at block B (" & ex.Message & ")")
End Try

Try	'---------- Block C: go through data collected with XML file and update the HS devices
	strStopDev = Cint(pwCOUNT)
	For strCount = strStartDev to strStopDev
		varITEM = ""
		varITEM = hs.stringitem(strDATA,strCount+1,"CDATA[")
		If strDebug > 0 then hs.writelog(varVersion,"-- ITEM:" & varITEM)
		varDATA = ""
		varDATA = hs.stringitem(varITEM,1,"]]")
		If Len(varDATA)=0 then hs.writelog (varVersion,"varDATA contains no data")
		If strDebug > 0 then hs.writelog(varVersion,"-- DATA:" & varDATA)
		If strDebug > 0 then hs.writelog(varVersion,"..................")
		If strDebug > 0 then hs.writelog(varVersion,"-- ITEM3: " & hs.stringitem(strDATA,4,"CDATA["))
		pwID 	  = Trim(hs.stringitem(varDATA,1,","))
		pwCURRENT = Mid(Trim(hs.stringitem(varDATA,2,",")),3)
		pwSTATUS  = Mid(Trim(hs.stringitem(varDATA,3,",")),3)
		pwTOTAL   = Mid(Trim(hs.stringitem(varDATA,4,",")),3)
		pwTOTAL   = Mid(pwTOTAL,1,Instr(pwTOTAL,".")-1)
		pwSWITCH  = Mid(Trim(hs.stringitem(varDATA,5,",")),3)
		pwONLINE  = Mid(Trim(hs.stringitem(varDATA,6,",")),3)

		If strDebug > 0 then hs.writelog(varVersion,"<b>pwID: " & pwHC & pwID & "</b>")
		If strDebug > 0 then hs.writelog(varVersion,"pwCURRENT: " & pwCURRENT)
		If strDebug > 0 then hs.writelog(varVersion,"pwSTATUS: " & pwSTATUS)
		If strDebug > 0 then hs.writelog(varVersion,"pwTOTAL: " & pwTOTAL)
		If strDebug > 0 then hs.writelog(varVersion,"pw(cannot)SWITCH: " & pwSWITCH)
		If strDebug > 0 then hs.writelog(varVersion,"pwONLINE: " & pwONLINE)

		If pwSTATUS = "on" then
			pwICON = "<img src='images\DJ_Plugwise_ledON.gif' align=absmiddle>"
			If hs.DeviceStatus(pwHC & pwID) <> 2 then 
				hs.WriteLog(varVersion,"<b>Device:" & pwHC & pwID & " status is:" & hs.DeviceStatus(pwHC & pwID) & " and should be:2 (ON)</b>")
				hs.setdevicestatus(pwHC & pwID,2)
			End if
		elseif pwSTATUS = "off" then
			pwICON = "<img src='images\DJ_Plugwise_ledOFF.gif' align=absmiddle>"
			If hs.DeviceStatus(pwHC & pwID) <> 3 then 
				hs.WriteLog(varVersion,"<b>Device:" & pwHC & pwID & " status is:" & hs.DeviceStatus(pwHC & pwID) & " and should be:3 (OFF)</b>")
				hs.setdevicestatus(pwHC & pwID,3)
			End if
		elseif pwSTATUS = "unknown" then
			pwICON = "<img src='images\DJ_Plugwise_alert.gif' align=absmiddle>"
		end if		
		If pwSWITCH="True" and pwSTATUS<>"unknown" then pwICON = "<img src='images\DJ_Plugwise_ledgray.gif' align=absmiddle>"
		
		pwHOUSETOTAL = pwHOUSETOTAL + Cint(pwCURRENT)
		pwSTRING = pwICON & " " & pwCURRENT & " W <font size=1>(" & pwTOTAL & " kWh)</font>"
		If strDebug > 0 then hs.writelog(varVersion,"pwSTRING:" & pwSTRING)
		hs.setdevicestring (pwHC & pwID, pwSTRING & "<br>", TRUE)
		hs.setdevicevalue (pwHC & pwID, Cint(pwCURRENT))
	Next
	If len(pwDCtotal) > 0 and strDevice = "" then 
		hs.setdevicestring (pwDCtotal, "<img src='images\DJ_Plugwise_ledblue.gif' align=absmiddle> " & pwHOUSETOTAL & " <font size=1>W</font>", TRUE)
		hs.setdevicevalue (pwDCtotal, pwHOUSETOTAL)
	end if
Catch ex As Exception
	hs.writelog(varVersion,"Error at block C (" & ex.Message & ")")
End Try

If strDebug > 0 then hs.writelog(varVersion,"<b>FINISHED</b>")
End Sub

