﻿' -----------------------------------------------------------------------------------------
'                          PLUGWISE switching  for HOMESEER
'		   by DJF3 - http://www.domoticaworld.com - info@domoticaworld.com
' -----------------------------------------------------------------------------------------
' version 0.8 - Mar-01 2011
'	Updated image names (green to ON and gray to OFF). Use this script with the .10 version of my Plugwise script
' version 0.7 - Aug-30 2009
'	Stopped using status devices (strStatusDevice). Set and get status from the actual plugwise device.
'	Stop using the statusdevice PARAMETER for this script - check "HOW" below
'	Added code that retrieves the deviceNAME
'	Rewrote entire code. (also changed debug levels)
' version 0.6 - Aug-26 2009
'	Removed all references to device-values (using status, not values)
' version 0.5 - Aug-23 2009
'	Modified code, only using devicestatus=2 (ON) or =3 (oFF). If device doesn't have this value it will be switched off.
' version 0.4 - July-1 2009
'	Modified code to use devicestatus ON/OFF instead of weird (non-standard) devicevalues (2=ON 3=OFF)
'	Fixed logging name (now set to DJ_SwitchPlugwise)
' version 0.3 - June-24 2009
'	Added code that checks IF the strStatusDevice is available, if not it will also work.
'	Added some troubleshooting code, updated writelogs to include strStatusDevice numbers
' version 0.2 - May-01 2009
'	Added extra parameter that (if used) sets the Plugwise status in seperate device
'		This is used for HS Touch device status of Plugwise devices.
' version 0.1 - Dec-06 2008
'	First release.
'HOW
'	- Call script with parameter: ("Main","Q28;On")
'	   Q=house-code, 28 = Plugwise device-id AND HomeSeer device-code. These need to be the SAME!
'	   Optional: "On" or "Off". If not set it will switch the status from off->on and on->off
' SEE the readme.txt in version 0.10 of my Plugwise script (on homepage) for instructions !!
' -----------------------------------------------------------------------------------------

Sub Main(ByVal strAppCmd As String)
	Dim strReturn, strWebsite As String
	Dim strDebug as Integer
	Dim strPWdevice As String = hs.stringitem(strAppCmd, 1, ";")
	Dim strCmd As String
	Dim strCommand As String = hs.stringitem(strAppCmd, 2, ";")
	Dim strPWstatus As Integer
	strDebug = 0

	If strDebug > 0 then hs.writelog("....","")
	
	'DJ: get current device status
	strPWstatus = hs.devicestatus(strPWdevice)
	
	strCommand = UCase(strCommand)
	If strDebug > 0 then hs.WriteLog("DJ_SwitchPlugwise1","Device:" & strPWdevice & "(<b>" & GetDeviceName(strPWdevice) & "</b>) strCommand=" & strCommand & "     STATUS:" & Cstr(hs.DeviceStatus(strPWdevice)))
	
	'DJ: If device status <> 2 and <>3 then ERROR.
	If strPWstatus <> 2 and strPWstatus <> 3 then hs.writelog("DJ_SwitchPlugwise","ERROR: Device " & strPWdevice & "(<b>" & GetDeviceName(strPWdevice) & "</b>)  has STATUS:" & strPWstatus)
	
	If strCommand = "" and strPWstatus < 4 then   		'-------------------- COMMAND = EMPTY
		'DJ: NO command, status 3 OFF --- turn ON device
		If strPWstatus = 2 then
			If strDebug > 0 then hs.WriteLog("DJ_SwitchPlugwise2","STATUS was <b>3</b> (off) --- device " &  "(<b>" & GetDeviceName(strPWdevice) & "</b>) will be switched <b>ON</b>")
			strCmd = "On"
			hs.SetDeviceString(strPWdevice, Replace(hs.DeviceString(strPWdevice),"OFF","ON"))
		'DJ: NO command, status 2 ON --- turn OFF device
		Else If strPWstatus = 3 then
			If strDebug > 0 then hs.WriteLog("DJ_SwitchPlugwise3","STATUS was <b>2</b> (on) --- device " & strPWdevice &  "(<b>" & GetDeviceName(strPWdevice) & "</b>) will be switched <b>OFF</b>")
			strCmd = "Off"		
			hs.SetDeviceString(strPWdevice, Replace(hs.DeviceString(strPWdevice),"ON","OFF"))
		End If
	Else If strCommand = "ON" and strPWstatus < 4 then	'-------------------- COMMAND = ON
		'DJ: Command = on, status 2 ON --- do NOTHING
		If strPWstatus = "3" then 
			If strDebug > 0 then hs.writelog("DJ_SwitchPlugwise4","Do nothing - device " & strPWdevice &  "(<b>" & GetDeviceName(strPWdevice) & "</b>) already ON")
		Else
			strCmd = "On"
			If strDebug > 0 then hs.WriteLog("DJ_SwitchPlugwise5","STATUS was <b>" & Cstr(hs.DeviceStatus(strPWdevice)) & "</b>--- device " & strPWdevice &  "(<b>" & GetDeviceName(strPWdevice) & "</b>) will be switched <b>ON</b>")
			hs.SetDeviceString(strPWdevice, Replace(hs.DeviceString(strPWdevice),"OFF","ON"))
		End If
	Else If strCommand = "OFF" and strPWstatus < 4 then	'-------------------- COMMAND = OFF
		'DJ: Command = off, status 3 OFF --- do NOTHING
		If strPWstatus = "2" then 
			If strDebug > 0 then hs.WriteLog("DJ_SwitchPlugwise6","Do nothing - device " & strPWdevice &  "(<b>" & GetDeviceName(strPWdevice) & "</b>) already OFF")		
		Else
			strCmd = "Off"
			If strDebug > 0 then hs.WriteLog("DJ_SwitchPlugwise7","STATUS was <b>" & Cstr(hs.DeviceStatus(strPWdevice)) & "</b>--- device " & strPWdevice &  "(<b>" & GetDeviceName(strPWdevice) & "</b>) will be switched <b>OFF</b>")
			hs.SetDeviceString(strPWdevice, Replace(hs.DeviceString(strPWdevice),"ON","OFF"))
		End If
	Else
		hs.writelog("DJ_SwitchPlugwise8","ERROR: Command=" & strCommand & "(not empty or On/Off) dev:" & strPWdevice &  "(<b>" & GetDeviceName(strPWdevice) & "</b>) status:" & hs.DeviceStatus(strPWdevice))
	End If
	If strCmd = "" then
		If strDebug > 0 then hs.writelog("DJ_SwitchPlugwise9","Device <b>" & strPWdevice & "</b> " &  "(<b>" & GetDeviceName(strPWdevice) & "</b>) was already ON or OFF --- strCmd=EMPTY, STATUS: " & Cstr(hs.DeviceStatus(strPWdevice)))
	Else 
		strWebsite = "http://10.1.1.55:8181/cc.html?applid=" & Mid(strPWdevice,2) & "&cmd=" & strCmd
		strReturn = hs.URLAction(strWebsite, "GET", "", "")
		If strDebug > 1 then hs.writelog("DJ_SwitchPlugwise10","URL send:" & strWebsite)
		If strDebug > 1 then hs.writelog("DJ_SwitchPlugwise11","Command:" & strCmd & " and DEVICESTRING:" & hs.DeviceString(strPWdevice))
	End If
	If strDebug > 0 then hs.writelog("....","")
End Sub

function GetDeviceName(sDeviceCode)
	dim iRef
    iRef = hs.DeviceExistsRef(sDeviceCode)
    if iRef > -1 then
        GetDeviceName = hs.GetDeviceByRef(iRef).name
    else
        GetDeviceName = "Unknown"
    end if
end function